class add_source {
  class { 'apt':  }

  file { "/etc/apt/apt.conf.d/99auth":
    owner => root,
    group => root,
    content => "APT::Get::AllowUnauthenticated yes;",
    mode => 644;
  }

  # tmux ppa
  apt::ppa { 'ppa:pi-rho/dev': }

  # git ppa
  apt::ppa { 'ppa:git-core/ppa': }

  # node.js ppa
  apt::ppa { 'ppa:chris-lea/node.js': }
}

class pre_install {
  package { [
    'libboost-python-dev','g++','libcrypto++-dev', 'ctags', 'zsh', 'make',
    'vim', 'tmux', 'build-essential', 'curl', 'gettext', 'bpython', 'ipython',
    'pep8', 'python-pip', 'nodejs', 'unzip'
  ]:
    ensure => 'latest'
  }
}

class pre_settings {
  # install zsh
  exec { 'root_install_zsh':
    command =>
      'wget -O - https://raw.github.com/JustinTW/rc/develop/auto-install.sh | sh',
    path => ['/usr/bin/','/usr/sbin/','/bin'],
    user=> 'root'
  }
  exec { 'user_install_zsh':
    command =>
      'wget -O - https://raw.github.com/JustinTW/rc/develop/auto-install.sh | sh',
    path => ['/usr/bin/','/usr/sbin/','/bin'],
    user=> 'vagrant'
  }
  exec { 'root_change_shell':
    command =>
      'chsh -s /usr/bin/zsh root',
    path    => ['/usr/bin/','/usr/sbin/','/bin'],
    user    => 'root',
    require => Exec['root_install_zsh']
  }
  exec { 'user_change_shell':
    command =>
      'chsh -s /usr/bin/zsh vagrant',
    path    => ['/usr/bin/','/usr/sbin/','/bin'],
    user    => 'vagrant',
    require => Exec['user_install_zsh']
  }
}

class develop_environment {

  Exec {
    path => ['/usr/sbin', '/usr/bin', '/sbin', '/bin', '/usr/local/bin']
  }

  class { 'add_source': }
  class { 'pre_install':  require => Class['add_source'] }
  class { 'pre_settings': require => Class['pre_install'] }
}
